import os

import matplotlib.pyplot as plt
import numpy as np
import scipy.stats

# TODO try truncated data as well!
# folder = "/Volumes/DATA/Barrett_Hand/foams_s0'3/a1/"
folder = "/Volumes/DATA/Barrett_Hand/foams_s0'3/a1_trunc/"


def get_features(x, segments=1):
    seg_length = int(len(x) / segments)
    features = []
    for i in range(segments):
        x_seg = x[i * seg_length:(i + 1) * seg_length]
        features.append(np.min(x_seg))
        features.append(np.max(x_seg))
        features.append(np.mean(x_seg))
        features.append(scipy.stats.kurtosis(x_seg))
        features.append(scipy.stats.skew(x_seg))
        features.append(np.median(x_seg))
        features.append(np.std(x_seg))
        diff_x = np.diff(x_seg)
        diff2_x = np.diff(diff_x)
        features.append(np.max(np.abs(diff_x)))  # Diff 1 − Max
        features.append(np.max(np.abs(diff2_x)))  # Diff 2 − Max
        features.append(np.mean(np.abs(diff_x)))  # Diff 1 − Mean
        features.append(np.mean(np.abs(diff2_x)))  # Diff 2 − Mean
        features.append(np.trapz(x_seg))

    return features


def load_npz(path):
    measurement = np.load(path)
    tact_palm = measurement['palm'].astype('float32')
    tact_f1 = measurement['f1'].astype('float32')
    tact_f2 = measurement['f2'].astype('float32')
    tact_f3 = measurement['f3'].astype('float32')
    tact_t = measurement['tact_t']
    joint_coords = measurement['coords'].astype('float32')
    joint_effort = measurement['effort'].astype('float32')
    joint_t = measurement['joint_t']

    joint_effort = joint_effort.transpose()
    joint_effort = np.array(
        [joint_effort[0], joint_effort[4], joint_effort[5]])  # select just the fingertip sensors
    joint_effort = joint_effort.transpose()

    seq_len = min(len(joint_t), len(tact_t))
    stacked_array = np.hstack([tact_palm[:seq_len], tact_f1[:seq_len], tact_f2[:seq_len],
                               tact_f3[:seq_len], joint_effort[:seq_len], joint_coords[:seq_len]])
    return stacked_array


num_measurements = None
segments = 3
num_features = 12 * segments
num_sensors = 96 + 3 + 8  # tactile + torque + joint
k = 2  # diemnsion of serached subspace
downsampling = 8  # this will kepp each n-th value
# my reason for downsampling is the redundancy of tactile data (prints data at 200 Hz but really refreshes only at cca 25 Hz)

with os.scandir(folder) as entries:
    npz_entries = []
    for entry in entries:
        if entry.name.endswith('.npz'):
            npz_entries.append(entry)

    num_measurements = len(npz_entries)
    m = num_measurements  # number of measurements/vectors
    n = num_sensors * num_features  # number of values/dimension
    feature_matrix = np.zeros((m, n))

    for i, entry in enumerate(npz_entries):
        npz_file = folder + entry.name
        measurement = load_npz(folder + entry.name)
        feature_sensor_matrix = np.zeros((num_sensors, num_features))

        for i, row in enumerate(measurement.T):
            downsampled_row = row[::downsampling]
            # print(row.shape)
            # print(downsampled_row.shape)
            feature_sensor_matrix[i] = get_features(
                downsampled_row, segments=segments)

        feature_vector = np.reshape(feature_sensor_matrix, (n))
        feature_matrix[i] = feature_vector

A = feature_matrix  # m x n
a0 = np.array(sum(A) / m)  # center of mass
A_lin = A - a0  # transformation of affine space to linear

C = np.dot(A_lin.T, A_lin)
values, vectors = np.linalg.eig(C)  # spectral decomposition

indices = values.argsort()  #  sort ascending --> largest eigenvalue at the end
values = values[indices]
vectors = vectors[:, indices]

# X = V(:, 1: n-k)
Y = vectors[:, range(n - k, n)]  # ortonormal basis of searched subspace
B = np.dot(A_lin, np.dot(Y, Y.T))

# shift back the points by a0 and get coefficients of linear combination, coef = point . basis_vector
B_coordY = np.dot(B + a0, Y)
# can be substituted to get B_coordY = A*Y

for i in range(m):
    plt.scatter(B_coordY[i, 0], B_coordY[i, 1])

plt.show()


# Testing matrix for volby2017
# matrix = [[1, 1, 1, 1, -1, 1, 1, 1, 1, 1, -1, -1, -1, -1, -1, 1, -1, 1, -1, 1, 1, 1, 1, 1, -1, 1, -1, 1, -1, 1, -1, -1, -1, -1, 1, -1, -1, 1, -1, 1, -1, 1, 1, 1, -1, -1, 1, 1, 1, 1, 1, -1, -1, 1, -1, -1, 1, 1, -1, -1, 1, -1, 1, -1, -1, -1, 1, -1, 1, -1, -1, -1, -1, 1, 1, 1, 1, 1, -1, -1, 1, 1, 1, 1, -1, -1, 1, -1, -1, 1, 1, -1, -1, -1, -1, -1, -1, -1, -1, 1],
#           [1, 1, -1, 1, 1, -1, -1, -1, -1, -1, 1, -1, -1, -1, 1, 1, 1, 1, 1, 1, 0, 1, 1, -1, 0, 1, -1, -1, -1, -1, 0, -1, -1, -1, 1, -1, -1, 1, 0, -1, 1, 1, -1, -1, 1, 1, 1, 1, 1, 1, -
#               1, 1, -1, 1, -1, -1, -1, 1, -1, -1, 0, -1, 0, -1, -1, -1, 1, 1, 1, 1, -1, -1, -1, 1, 1, 1, 1, 1, -1, 1, 1, 1, 1, 1, 1, -1, 1, -1, -1, 1, 1, -1, -1, 0, -1, -1, 1, 1, 1, 1],
#           [1, 0, -1, 1, -1, -1, 0, -1, 0, 0, -1, 0, 1, -1, 1, -1, 0, 1, 1, -1, 0, 1, 0, 0, -1, 1, -1, 1, -1, 1, 1, -1, -1, 0, -1, -1, -1, 1, 0, 1, 1, 1, 0, -1, 0, 0, 1, 1, 1, -
#               1, -1, 1, -1, 1, 0, 1, 0, 1, 1, 0, -1, -1, 0, -1, 0, -1, 1, 1, -1, 1, 1, -1, 1, 1, 0, -1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0, 1, 1, -1, 1, 1, -1, 1, 1, 0, 1, 1, 1, -1, -1],
#           [-1, -1, 0, 0, -1, -1, -1, 1, -1, 0, -1, -1, -1, -1, -1, 1, 1, 1, 1, 1, 0, -1, -1, 1, -1, -1, -1, 1, 1, 1, -1, 1, 0, 1, -1, 0, 0, 1, -1, 1, -1, 1, 1, -1, -1, 1, 1, 1, 1, -1, 0,
#            0, 0, 1, -1, -1, -1, -1, -1, 0, 1, -1, 0, -1, 0, -1, 0, -1, -1, -1, -1, -1, -1, 1, -1, 1, 1, 1, -1, -1, 0, 1, 1, 1, -1, -1, 1, -1, -1, -1, -1, 0, -1, -1, -1, -1, -1, 0, -1, 1],
#           [1, 1, 1, 1, 1, 1, 1, 1, 0, 1, -1, 1, -1, -1, -1, -1, -1, 1, 0, -1, 1, 1, -1, 1, 1, 1, 1, 1, -1, 1, -1, 1, -1, 1, -1, -1, -1, 1, -1, 1, 1, 1, 1, -1, -1, -1, 1, 1, 1, -1,
#            1, -1, -1, 1, -1, -1, -1, 1, 1, 1, 1, -1, -1, -1, 1, -1, 1, 1, 1, 1, 1, 1, 1, -1, 1, 0, 0, 1, 0, -1, -1, -1, 1, 1, 1, 1, 1, 1, -1, 0, 1, -1, 0, 1, 0, 1, 1, 1, 0, 1],
#           [-1, -1, 1, 1, -1, -1, -1, -1, -1, -1, 1, -1, -1, -1, 1, 1, 1, 1, 1, 1, 1, 1, 1, -1, -1, -1, -1, 1, -1, -1, -1, 1, 1, 1, -1, 1, 1, 1, -1, -1, -1, 1, 1, -1, 1, 1, 1, 1, 1, 1, -1,
#            1, 1, 1, -1, -1, -1, -1, -1, -1, 1, -1, -1, -1, -1, -1, -1, -1, -1, 1, -1, -1, -1, 1, 1, 1, 1, 1, -1, -1, 1, 1, 1, 1, -1, -1, 1, -1, -1, -1, 1, 1, -1, -1, 1, -1, -1, -1, -1, -1],
#           [1, 1, 1, 1, 1, 1, -1, -1, -1, -1, 0, -1, -1, -1, 1, 1, 1, 1, 1, 0, -1, 1, 1, 1, 1, 1, -1, 1, 1, 1, 0, 1, -1, 1, -1, -1, -1, 1, 1, 0, -1, 1, 1, -1, 1, -1, 1, 1, 1,
#            0, -1, 1, -1, 1, -1, -1, -1, 1, 0, 1, 1, -1, 1, -1, 1, -1, 1, 1, 1, 0, 0, -1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, -1, 0, 1, 0, -1, -1, 1, -1, 1, 1, 0, 0, 1, 1, 0, -1],
#           [1, -1, 1, 1, -1, -1, -1, -1, -1, -1, 1, -1, -1, -1, 1, 1, 1, 1, 1, 1, 1, 1, 1, -1, -1, 1, -1, 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, -1, -1, -1, 1, -1, 0, 1, 1, 1, 1, 1, -1, -1,
#            1, -1, 1, -1, -1, -1, -1, 1, -1, 1, -1, -1, 1, -1, -1, 1, 1, 1, -1, -1, -1, -1, 1, -1, 1, 1, 1, -1, -1, 1, 1, 1, 1, -1, -1, 1, 1, -1, 1, 1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
#           [-1, -1, 1, 1, -1, 1, -1, -1, -1, -1, 1, -1, -1, -1, 1, 1, 1, 1, 1, 1, -1, 1, 1, -1, -1, 0, -1, 1, -1, 1, 1, -1, 1, -1, -1, -1, 1, -1, -1, -1, -1, 1, 1, -1, 1, 1, 1, 1, 1, -1, -
#            1, 1, -1, -1, -1, -1, -1, -1, -1, -1, 1, -1, -1, -1, 1, -1, 1, -1, 1, -1, -1, -1, 1, 1, 1, 1, 1, -1, -1, 1, 1, 1, -1, 1, -1, -1, 1, 1, 1, -1, 1, 1, -1, 1, 1, 1, 1, -1, 1, -1],
#           [1, 1, 1, 1, 1, 0, -1, -1, -1, -1, 1, -1, -1, 1, 1, 0, 1, 1, 1, 1, -1, 1, 1, -1, 1, 1, -1, 1, -1, -1, 0, 0, -1, 1, -1, -1, -1, 1, 1, 1, 1, 1, -1, -1, 1, 1, 1, 1, 1,
#            1, -1, 1, -1, 1, 1, 1, 1, 1, 1, 1, 1, -1, 1, -1, -1, -1, 1, 1, 1, 1, -1, -1, -1, 1, 1, 1, 1, 1, 1, 1, 1, -1, -1, 1, -1, 1, 1, 1, 1, 1, -1, -1, 0, 0, 1, 1, 1, 1, -1, -1],
#           [1, -1, 1, 1, -1, 1, -1, -1, -1, -1, -1, 1, -1, -1, -1, -1, -1, 1, -1, -1, 1, -1, -1, 1, -1, -1, -1, 1, 1, 1, -1, 1, 1, 1, -1, -1, -1, 1, -1, -1, -1, 1, 1, -1, -1, 1, 1, 1, 1, -1, -
#            1, 1, 1, -1, -1, -1, -1, 1, 1, 1, 1, -1, 0, -1, 0, -1, 1, -1, 1, -1, 1, 1, -1, -1, 1, 1, -1, 1, -1, -1, -1, 1, -1, -1, 1, 1, 1, 0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1],
#           [1, -1, -1, 1, -1, 1, -1, 0, 1, 1, -1, -1, -1, -1, -1, 1, 1, 1, -1, -1, 1, -1, -1, 1, -1, -1, 1, -1, 1, 1, -1, 1, 0, 1, -1, 0, 1, 0, -1, -1, -1, 1, 1, -1, 1, 1, -1, 1, 1, -1, 1,
#            0, 0, -1, -1, -1, -1, -1, -1, 0, 1, 0, 0, -1, 0, -1, 0, -1, 1, 1, -1, -1, -1, -1, 1, 1, -1, -1, -1, 1, -1, 1, 1, -1, 1, -1, 1, -1, -1, -1, -1, 1, -1, -1, -1, -1, -1, -1, -1, 1],
#           [1, 1, -1, 1, 1, 1, 1, 1, 1, 1, -1, 1, 1, -1, -1, -1, -1, 1, -1, -1, 1, -1, -1, 1, -1, 1, -1, 1, 1, 1, 1, 1, -1, 1, -1, -1, -1, 1, -1, 1, 0, 1, 1, -1, -1, -1, 1, -1, 1, -1, -
#            1, -1, -1, 1, -1, -1, -1, 1, -1, -1, 1, 1, -1, 0, 0, -1, 1, 1, -1, -1, 1, -1, -1, 1, 1, -1, -1, 1, -1, 0, -1, 1, 1, -1, 0, 1, 1, 1, 1, -1, -1, -1, -1, 1, -1, -1, -1, -1, -1, 1],
#           [1, 1, -1, 1, -1, 1, 1, 1, 1, 1, -1, 1, 1, -1, -1, -1, -1, -1, -1, -1, 1, -1, -1, 1, -1, 1, -1, -1, 1, 1, -1, 1, -1, 1, -1, -1, -1, 1, -1, -1, 1, 1, 1, -1, -1, -1, 1, 1, -1, -1,
#            1, -1, -1, 1, -1, -1, -1, 1, -1, 1, 1, -1, -1, -1, -1, -1, 1, 1, 1, -1, 1, 0, -1, 1, 1, -1, -1, -1, -1, 0, -1, 1, 1, -1, 1, -1, 1, 1, -1, -1, 1, -1, -1, 1, -1, -1, -1, 1, -1, 1],
#           [1, 1, -1, 1, -1, 1, -1, 0, 1, 1, -1, 0, 0, -1, -1, -1, 1, 1, -1, -1, 0, 0, -1, 1, 1, 0, -1, -1, 1, 1, 0, 1, -1, 1, -1, -1, -1, 1, -1, -1, 1, 1, 0, -1, 1, -1, 1, 1, 1, -1,
#            1, 1, 1, -1, -1, -1, -1, 1, 1, 1, 1, -1, 0, -1, -1, -1, 1, 1, 1, 0, 0, -1, 1, 1, 1, -1, 0, 1, 1, 1, 0, -1, -1, 1, -1, 1, 1, 1, -1, -1, 0, 0, -1, 1, 1, 1, 1, 1, -1, 0],
#           [1, 1, -1, 1, 1, -1, 1, 1, 1, 1, -1, 1, 1, -1, -1, -1, -1, -1, -1, -1, 1, -1, -1, -1, -1, -1, -1, -1, -1, 1, -1, 1, -1, 1, -1, -1, -1, 1, -1, -1, 1, 1, 1, -1, 1, -1, 1, 1, -1, -1,
#            1, -1, -1, -1, -1, -1, 1, 1, -1, -1, 1, 1, -1, -1, -1, -1, 1, 1, -1, 1, -1, -1, 1, 1, 1, -1, -1, -1, 1, 1, -1, 1, 1, -1, -1, -1, 1, 1, -1, -1, -1, -1, -1, 1, -1, -1, -1, -1, -1, 1],
#           [1, 1, 1, 1, -1, 1, 1, 1, 1, 1, -1, 1, -1, -1, -1, -1, -1, 1, -1, -1, 1, -1, 1, 1, 1, 1, -1, 1, 1, 1, -1, 1, -1, 1, -1, -1, -1, 1, 1, 1, 1, 1, 1, -1, -1, -1, 1, 1, 1, -1,
#            1, -1, -1, 1, -1, -1, -1, 1, -1, 1, 1, -1, -1, -1, 1, -1, 1, 1, 1, 1, 1, -1, 1, 1, 1, 1, -1, 1, -1, 1, -1, 1, 1, -1, -1, -1, 1, -1, 1, 1, 1, -1, 1, 1, 1, 1, -1, 1, 1, 1],
#           [1, 1, -1, 1, 1, -1, -1, 1, 1, 1, 1, 1, -1, -1, 1, -1, -1, 1, -1, -1, -1, -1, 1, 1, -1, 1, -1, 1, 1, 1, -1, 1, -1, 1, -1, -1, -1, 1, 1, -1, -1, 1, -1, -1, 1, -1, 1, 1, 1, -1,
#            1, -1, -1, 1, -1, -1, -1, 1, 1, 1, 1, -1, 1, -1, -1, -1, 1, 1, 1, 1, 1, 1, -1, 1, -1, -1, 1, 1, -1, 1, 1, -1, -1, 1, 1, -1, 1, 1, -1, 1, 1, -1, -1, -1, -1, 1, 1, 1, 1, 1],
#           [-1, 1, 1, 1, -1, 1, -1, -1, -1, 0, 1, -1, -1, -1, 1, 1, 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, -1, 1, 0, 1, 0, -1, -1, -1, -1, -1, -1, 0, -1, 1, 0, 1, -1, -1, -1, -1, 1, 0, 0, -1,
#            1, 0, 1, 0, -1, -1, 0, 1, -1, 1, 1, -1, 0, -1, -1, 1, 1, 1, 0, -1, 1, -1, 1, 1, 1, 1, -1, 0, 1, 1, 0, -1, -1, 1, 1, 1, 0, -1, -1, 1, -1, 1, -1, 1, 0, 0, -1, 0, 1, 1],
#           [-1, -1, 1, -1, 0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 1, 1, 1, 0, -1, 1, 1, 1, 1, -1, -1, 1, 1, 1, 1, 1, 1, 1, -1, -1, -1, 1, 1, 0, 1, 1, -1, -1, 1, -1, 1, 1, 1,
#            1, -1, -1, 1, -1, -1, -1, -1, 0, 1, 1, 1, -1, 1, -1, 1, -1, 1, -1, -1, 0, -1, 1, 1, 1, -1, 1, 1, 1, -1, 0, 1, 1, 1, -1, -1, 1, 1, 1, -1, -1, -1, 1, 1, 1, 0, 0, -1, 1, 1, 1],
#           [1, 1, 1, 1, 1, 1, -1, 0, 0, 0, -1, 1, -1, -1, -1, -1, -1, 1, -1, -1, 1, -1, -1, 1, -1, -1, -1, 1, 1, 1, -1, 1, -1, 1, -1, -1, -1, 1, -1, 1, -1, 1, 1, -1, 1, -1, 1, 1, 1, -1, -
#            1, -1, -1, 1, -1, -1, -1, 1, -1, 1, 1, -1, 0, -1, 1, -1, 1, 1, 1, -1, 1, -1, 1, 1, 1, 1, 1, 1, -1, -1, -1, 1, 1, 1, 1, 1, 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1],
#           [1, 1, -1, 1, -1, -1, 1, 1, 1, 1, -1, -1, -1, -1, -1, -1, -1, 1, -1, -1, 1, -1, -1, 1, -1, 1, -1, 1, 1, -1, -1, -1, -1, -1, 1, -1, -1, 1, -1, -1, -1, 1, 1, 1, -1, -1, 1, 1, 1, -1,
#            1, -1, -1, 1, -1, -1, -1, -1, -1, -1, -1, 1, -1, -1, 1, -1, 1, 1, 1, 1, 1, -1, 1, 1, 1, -1, -1, 1, 1, -1, -1, 1, 1, 1, -1, -1, 1, -1, -1, 1, 1, -1, -1, 1, -1, -1, -1, -1, -1, 1],
#           [1, 1, -1, 1, 1, 0, 0, 1, 1, 1, -1, 1, 0, -1, -1, -1, -1, 0, -1, -1, 1, -1, -1, 1, -1, 1, -1, 0, 1, 1, -1, 1, -1, 1, -1, -1, -1, 1, -1, 1, -1, 1, 1, -1, 0, -1, 1, 0, 0, -1,
#            0, -1, -1, 0, -1, -1, -1, -1, -1, 0, 0, 1, -1, 0, -1, -1, 1, 1, 1, 1, 1, 0, 1, 1, 1, -1, 0, 1, -1, 1, -1, 1, 0, -1, 0, 1, 1, 1, -1, -1, -1, -1, -1, 0, 0, 0, -1, 1, 0, 1],
#           [1, 1, -1, 1, 1, 1, -1, 1, 1, 1, -1, 0, 1, -1, 1, -1, -1, 0, -1, -1, 0, 0, 0, 1, -1, 1, -1, -1, -1, 0, -1, 0, -1, -1, -1, -1, -1, 1, -1, 1, 1, 1, 1, -1, -1, -1, 1, 1, 1, -1,
#            1, -1, -1, 1, -1, -1, -1, 1, 0, -1, 1, -1, -1, -1, 0, -1, 1, 1, 1, 1, 1, -1, 1, 1, 1, -1, -1, 1, 1, -1, 1, 1, 1, 0, 1, -1, 1, -1, -1, 0, -1, -1, 1, 1, -1, 0, 0, -1, -1, 1],
#           [1, 1, -1, 1, -1, 1, 1, 1, 1, 1, -1, 1, 1, -1, -1, -1, -1, 1, -1, -1, 0, -1, -1, 1, -1, 1, -1, -1, -1, 1, -1, 1, -1, 1, -1, -1, -1, 1, -1, 1, 1, 1, -1, -1, 1, -1, -1, 1, -1, -1, -1, -1, -1, 0, -1, -1, -1, 0, 1, -1, 1, 1, -1, -1, 0, -1, 1, 1, 1, 1, 1, -1, 1, 1, 1, 1, -1, 1, -1, -1, -1, 1, 1, 1, -1, -1, 1, -1, -1, -1, 1, -1, -1, -1, 1, 1, -1, 1, 1, 1]]
